import { SourceFile, MutantResult } from 'stryker-api/report';
import HandlebarsModel from './HandlebarsModel';
import SourceFileTreeLeaf from './SourceFileTreeLeaf';
export default class SourceFileTreeNode {
    name: string;
    leafs: SourceFileTreeLeaf[];
    children: SourceFileTreeNode[];
    model: HandlebarsModel;
    urlPrefix: string;
    constructor(name: string);
    addSourceFile(file: SourceFile, pathComponents?: string[]): void;
    addMutantResult(result: MutantResult, pathComponents?: string[]): void;
    normalizeNames(): void;
    calculateModel(urlPrefix: string): void;
    writeReportNodeRecursive(directory: string): void;
    toString(offset?: number): string;
    private static mutantStatusToString(status);
}
